<?php

 // THIS FILE IS PART OF WEBMATIC3 (Webmatic cube)
 // www.valarsoft.com

 defined('WM3_cEXEC') or die('Denied');

 class wm3MenuBar
  {

   function __construct() { }

   public static function getMenuBarItemFieldsArray()
    {
     return array('menu_bar_itemID','title','position',
	              'categoryID','pageID','url','subchannelID','target','link_external_url','link_external_target','linkID',
				  'enabled','languageID','ts');
    }

   public static function makeMenuBarItemLink($row)
    {
     // Make a menu item for menu bar from a "_menu_bars_items" row's (passing a row perform a minor number of queries)
     $str = "";
     switch($row->categoryID)
      {
       case WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM:
        {
         $str .= wm3Page::makePageLink($row->linkID,$row->title);
         break;
        }
       case WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL:
        {
         // TODO
         $str .= "<a href=\"".WM3_cCONFIG_ADMIN_FILE."?section=".WM3_cSECTION_CHANNELS."&subchannelID=$row->linkID\">$row->title</a>";
         break;
        }
       case WM3_cMENU_BAR_ITEM_CATEGORY_HOME:
        {
         $str .= "<a href=\"".WM3_cCONFIG_HOME_FILE."\">$row->title</a>";
         break;
        }
       case WM3_cMENU_BAR_ITEM_CATEGORY_ADMIN:
        {
         $str .= "<a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_ADMIN."\">$row->title</a>";
         break;
        }
       case WM3_cMENU_BAR_ITEM_CATEGORY_USER:
        {
         $str .= "<a href=\"".WM3_cCONFIG_ADMIN_FILE."?stage=".WM3_cSTAGE_USER."\">$row->title</a>";
         break;
        }
       case WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL:
        {
         $str .= "<a href=\"$row->url\" target=\"$row->target\">$row->title</a>";
         break;
        }
      }
     return $str;
    }

   public static function executeAction($w3)
    {
     switch($w3->getAction())
      {
       case WM3_cACTION_DISABLE_MENU_BAR_ITEM:
        {
         wm3MenuBar::disableMenuBarItem($w3,$w3->getVariable('menu_bar_itemID','get'));
         return wm3MenuBar::getMenuBarItemList($w3,$w3->getVariable('menu_bar_itemID','get'));
         break;
        }
       case WM3_cACTION_ENABLE_MENU_BAR_ITEM:
        {
         wm3MenuBar::enableMenuBarItem($w3,$w3->getVariable('menu_bar_itemID','get'));
         return wm3MenuBar::getMenuBarItemList($w3,$w3->getVariable('menu_bar_itemID','get'));
         break;
        }
       case WM3_cACTION_DELETE_MENU_BAR_ITEM:
        {
         wm3MenuBar::deleteMenuBarItem($w3,$w3->getVariable('menu_bar_itemID','get'));
         return wm3MenuBar::getMenuBarItemList($w3);
         break;
        }
       case WM3_cACTION_ADD_MENU_BAR_ITEM:
        {
         return wm3MenuBar::addMenuBarItem($w3);
         break;
        }
       case WM3_cACTION_EDIT_MENU_BAR_ITEM:
        {
         return wm3MenuBar::editMenuBarItem($w3);
         break;
        }
       case WM3_cACTION_SWAP_MENU_BAR_ITEM:
        {
         wm3MenuBar::swapMenuBarItem($w3);
         return wm3MenuBar::getMenuBarItemList($w3,$w3->getVariable('menu_bar_itemID','get'));
         break;
        }
       default:
        {
         return wm3MenuBar::getMenuBarItemList($w3);
        }
      }
    }

   public static function getPositions($w3)
    {
     // Create an array with menu item position
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                                   ORDER BY position");
     $i = 1; $_MPOS['up'][0] = 0;
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $_MPOS['up'][$i] = $_MPOS['down'][$i] = $row->menu_bar_itemID;
       $i++;
      }
     $m = $i-1; $_MPOS['down'][$i] = 0;
     for($i = $m;$i >= 1; $i--) $_MPOS['up'][$i]   = $_MPOS['up'][$i-1];
     for($i = 1;$i <= $m; $i++) $_MPOS['down'][$i] = $_MPOS['down'][$i+1];
     return $_MPOS;
    }

   public static function getPosition($w3,$menu_bar_itemID)
    {
     // Get the position of a menu item
     $rs = $w3->getDBObj()->query("SELECT position FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                             WHERE menu_bar_itemID = '$menu_bar_itemID'");
     $row = $w3->getDBObj()->fetch($rs);
     if($row) return $row->position;
    }

   public static function getMenuBarItemList($w3,$currentID = 0)
    {
     // Get menubar items list

     // Prepare variables to create the list
     $base_link = WM3_cCONFIG_ADMIN_FILE."?stage=".$w3->getStage()."&section=".$w3->getSection();
     $id_link   = '';

     // Do the query and take the total items number
     $query = "SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items ORDER BY position";
     $rs = $w3->getDBObj()->query($query);
     $total_items = $w3->getDBObj()->totalRows($rs);

     // Create list content
     $_DATA = array(); $p = 0; $found = false; $i = 1;
     $_MPOS = wm3MenuBar::getPositions($w3);
     while($row = $w3->getDBObj()->fetch($rs))
      {
       $link = $base_link.$id_link."&menu_bar_itemID=$row->menu_bar_itemID";

       // Move panels up and down buttons and panel info
       $_DATA[$p]->position = $row->position;
       if($_MPOS['up'][$i]   == 0) $_DATA[$p]->b1 = "<img src=\"".WM3_cPATH_DATA."action_equal.png\" width=\"24\" height=\"24\" align=\"absmiddle\">";
       else                        $_DATA[$p]->b1 = wm3Util::actionButton("$link&action=".WM3_cACTION_SWAP_MENU_BAR_ITEM."&swapID=".$_MPOS['up'][$i],"action_up.png",$w3->getWord(1279));
       if($_MPOS['down'][$i] == 0) $_DATA[$p]->b2 = "<img src=\"".WM3_cPATH_DATA."action_equal.png\" width=\"24\" height=\"24\" align=\"absmiddle\">";
       else                        $_DATA[$p]->b2 = wm3Util::actionButton("$link&action=".WM3_cACTION_SWAP_MENU_BAR_ITEM."&swapID=".$_MPOS['down'][$i],"action_down.png",$w3->getWord(1280));
       $lang_flag = "<img src=\"".WM3_cPATH_DATA.wm3Language::getFlag($w3,$row->languageID)."\" width=\"19\" height=\"13\" align=\"middle\"> (".wm3MenuBar::getMenuBarItemCategoryName($w3,$row->categoryID).")";
       $_DATA[$p]->title = wm3MenuBar::makeMenuBarItemLink($row);
       $_DATA[$p]->info  = $lang_flag;
       $i++;

       // Buttons
       if($row->enabled) $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_DISABLE_MENU_BAR_ITEM,"action_disable.png",$w3->getWord(180));
       else              $_DATA[$p]->b3 = wm3Util::actionButton("$link&action=".WM3_cACTION_ENABLE_MENU_BAR_ITEM,"action_enable.png",$w3->getWord(181));
       $_DATA[$p]->b4 = wm3Util::actionButton("$link&action=".WM3_cACTION_EDIT_MENU_BAR_ITEM,"action_edit.png",$w3->getWord(178));
       $_DATA[$p]->b5 = wm3Util::actionButton("$link&action=".WM3_cACTION_DELETE_MENU_BAR_ITEM,"action_delete.png",$w3->getWord(179),$w3->getWord(713));
       if($row->menu_bar_itemID == $currentID && !$found) { $currentID = $p; $found = true; }
       $p++;       
      }

     // Render List
     $list = new wm3GUIList($w3,$_DATA,$w3->getWord(174));
     $list->setTotalItems($total_items);
     if($found) $list->setCurrentID($currentID);
     $list->setCaptionLabels(array($w3->getWord(543),$w3->getWord(194),$w3->getWord(1407)));
     $list->setCaptionWidths(array(0,60,40));
     $list->setCaptionColspan(array(3,1,1,3));
     $list->setWidths(array(0,0,0,60,40));
     $list->setRenderPagesNavigator(false);
     return $list->render();
    }

   public static function addMenuBarItem($w3)
    {
	 // Initialize form
     $_FIELD = webmatic3::getPostValueArray(wm3MenuBar::getMenuBarItemFieldsArray());
	 $action = WM3_cACTION_ADD_MENU_BAR_ITEM;
	 require(WM3_cPATH_INCLUDE.'admin_menu_bar_item_form.inc');
     $form->setSubmitLabel($w3->getWord(191));
     $form->setTitle($w3->getWord(5));
     $form->setFieldsValues($_FIELD);

     // Render form
     if(!$form->wasSubmit())
      {
       // Default values for the form
       $_F['enabled']->setValue(WM3_cENABLED);
      }
     else
      {
       if($form->validate())
        {
         $lastID = wm3MenuBar::saveMenuBarItem($w3);
         return wm3MenuBar::getMenuBarItemList($w3,$lastID);
		}
      }

     // Operation to do before render the form
	 if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM || !$_FIELD['categoryID']) $_F['pageID']->setVisible(true);
	 if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL)                          $_F['subchannelID']->setVisible(true);
	 if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL)                         { $_F['link_external_url']->setVisible(true); $_F['link_external_target']->setVisible(true); }

     return $form->render();
    }

   public static function editMenuBarItem($w3)
    {
	 // Initialize form
	 $action = WM3_cACTION_EDIT_MENU_BAR_ITEM;
	 require(WM3_cPATH_INCLUDE.'admin_menu_bar_item_form.inc');
     $form->setSubmitLabel($w3->getWord(29));
     $form->setTitle($w3->getWord(171));

     // Render form
     if(!$form->wasSubmit())
      {
       // Take variables value from db
       $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                               WHERE menu_bar_itemID = '".$w3->getVariable('menu_bar_itemID','get')."'");
       $row = $w3->getDBObj()->fetch($rs);
	   if(!$row) return wm3GUIList::makeNotFoundItem($w3);
       $_FIELD = webmatic3::getRowValueArray(wm3MenuBar::getMenuBarItemFieldsArray(),$row);

       // Default value for fields not in $row object
       switch($_FIELD['categoryID'])
        {
         case WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM:   { $_FIELD['pageID']       = $_FIELD['linkID']; $_FIELD['subchannelID'] = 0; $_FIELD['link_external_url'] = $_FIELD['link_external_target'] = ''; break; }
         case WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL:  { $_FIELD['subchannelID'] = $_FIELD['linkID']; $_FIELD['pageID']       = 0; $_FIELD['link_external_url'] = $_FIELD['link_external_target'] = ''; break; }
	     case WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL: { $_FIELD['pageID'] = $_FIELD['subchannelID'] = 0; $_FIELD['link_external_url'] = $_FIELD['url']; $_FIELD['link_external_target'] = $_FIELD['target']; break; }
         default: { $_FIELD['pageID'] = $_FIELD['subchannelID'] = 0; $_FIELD['link_external_url'] = $_FIELD['link_external_target'] = ''; }
        }

       $form->setFieldsValues($_FIELD);
      }
     else
      {
       $_FIELD = webmatic3::getPostValueArray(wm3MenuBar::getMenuBarItemFieldsArray());
       $form->setFieldsValues($_FIELD);
       if($form->validate())
        {
         $lastID = wm3MenuBar::updateMenuBarItem($w3);
         return wm3MenuBar::getMenuBarItemList($w3,$lastID);
		}
      }

     // Operation to do before render the form
	 if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM || !$_FIELD['categoryID']) $_F['pageID']->setVisible(true);
	 if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL)                          $_F['subchannelID']->setVisible(true);
	 if($_FIELD['categoryID'] == WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL)                         { $_F['link_external_url']->setVisible(true); $_F['link_external_target']->setVisible(true); }

     return $form->render();
    }

   public static function saveMenuBarItem($w3)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items WRITE");

     $_FIELD = webmatic3::getPostValueArray(wm3MenuBar::getMenuBarItemFieldsArray(),WM3_cQUOTE_DB);
     $_FIELD['ts'] = time();
     switch($_FIELD['categoryID'])
      {
       case WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM:   { $_FIELD['linkID'] = $_FIELD['pageID'];  $_FIELD['url'] = $_FIELD['target'] = ''; break; }
       case WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL:  { $_FIELD['linkID'] = $_FIELD['subchannelID']; $_FIELD['url'] = $_FIELD['target'] = ''; break; }
	   case WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL: { $_FIELD['linkID'] = 0; $_FIELD['url'] = $_FIELD['link_external_url']; $_FIELD['target'] = $_FIELD['link_external_target']; break; }
       default: { $_FIELD['linkID'] = 0; $_FIELD['url'] = $_FIELD['target'] = ''; }
      }
     if($_FIELD['position'] <= 0) $_FIELD['position'] = 1; // If position its <= 0 (invalid position) the position will be 1
     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                       SET position = position + 1
                       WHERE position >= '".$_FIELD['position']."'");
     // The last array passed, will remove variables that are not used in the db table
     $w3->getDBObj()->saveAllTableFields('_menu_bars_items',$_FIELD,array('pageID','subchannelID','link_external_url','link_external_target'));

     $w3->getDBObj()->query("UNLOCK TABLES");
     return $w3->getDBObj()->getLastInsertID();
    }

   public static function updateMenuBarItem($w3)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items WRITE");
     
     $_FIELD = webmatic3::getPostValueArray(wm3MenuBar::getMenuBarItemFieldsArray(),WM3_cQUOTE_DB);
     
     wm3MenuBar::updateMenuBarItemPositions($w3,$_FIELD['menu_bar_itemID'],$_FIELD['position']);

     switch($_FIELD['categoryID'])
      {
       case WM3_cMENU_BAR_ITEM_CATEGORY_CUSTOM:   { $_FIELD['linkID'] = $_FIELD['pageID'];  $_FIELD['url'] = $_FIELD['target'] = ''; break; }
       case WM3_cMENU_BAR_ITEM_CATEGORY_CHANNEL:  { $_FIELD['linkID'] = $_FIELD['subchannelID']; $_FIELD['url'] = $_FIELD['target'] = ''; break; }
	   case WM3_cMENU_BAR_ITEM_CATEGORY_EXTERNAL: { $_FIELD['linkID'] = 0; $_FIELD['url'] = $_FIELD['link_external_url']; $_FIELD['target'] = $_FIELD['link_external_target']; break; }
       default: { $_FIELD['linkID'] = 0; $_FIELD['url'] = $_FIELD['target'] = ''; }
      }

     $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                       SET title      = '".$_FIELD['title']."',
                           linkID     = '".$_FIELD['linkID']."',
                           categoryID = '".$_FIELD['categoryID']."',
                           url        = '".$_FIELD['url']."',
                           target     = '".$_FIELD['target']."',
                           position   = '".$_FIELD['position']."',
                           enabled    = '".$_FIELD['enabled']."',
                           languageID = '".$_FIELD['languageID']."'
                       WHERE menu_bar_itemID = '".$_FIELD['menu_bar_itemID']."'");
                       
     $w3->getDBObj()->query("UNLOCK TABLES");
     return $_FIELD['menu_bar_itemID'];
    }

   public static function swapMenuBarItem($w3)
    {
     // Swap two item position (move up or down items)
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items WRITE");
     
     $menu_bar_itemID = $w3->getVariable('menu_bar_itemID','get');
     $swapID          = $w3->getVariable('swapID','get');     
     $swap_position   = wm3MenuBar::getPosition($w3,$swapID);
     $position        = wm3MenuBar::getPosition($w3,$menu_bar_itemID);

     if($position && $swap_position) // Swap effected only if the item exists (by checking the position)
      {
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                         SET position          = '$swap_position'
                         WHERE menu_bar_itemID = '$menu_bar_itemID'");
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                         SET position          = '$position'
                         WHERE menu_bar_itemID = '$swapID'");
      }

     $w3->getDBObj()->query("UNLOCK TABLES");
     return $menu_bar_itemID;
    }

   public static function updateMenuBarItemPositions($w3,$menu_bar_itemID,$new_position)
    {
     // Update the right item position when an item position changed
     $position = wm3MenuBar::getPosition($w3,$menu_bar_itemID);

     if($position) // Update effected only if the item exists (by checking the position)
      {
       if($new_position > $position)
        {
         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                           SET position = position - 1
                           WHERE position > '$position' AND position <= '$new_position'");

         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                           SET position          = '$new_position'
                           WHERE menu_bar_itemID = '$menu_bar_itemID'");
        }
       else
        {
         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                           SET position = position + 1
                           WHERE position >= '$new_position' AND position < '$position'");

         $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                           SET position          = '$new_position'
                           WHERE menu_bar_itemID = '$menu_bar_itemID'");
        }
      }
    }

   public static function disableMenuBarItem($w3,$menu_bar_itemID) { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items SET enabled = '".WM3_cDISABLED."' WHERE menu_bar_itemID = '$menu_bar_itemID'"); }

   public static function enableMenuBarItem($w3,$menu_bar_itemID)  { $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items SET enabled = '".WM3_cENABLED."'  WHERE menu_bar_itemID = '$menu_bar_itemID'"); }
   
   public static function deleteMenuBarItem($w3,$menu_bar_itemID)
    {
     $w3->getDBObj()->query("LOCK TABLES ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items WRITE");

     $position = wm3MenuBar::getPosition($w3,$menu_bar_itemID);
     if($position) // Update positions only if the deleted item exists (by checking the position)
      {
       $w3->getDBObj()->query("UPDATE ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items
                         SET position = position - 1
                         WHERE position > '$position'");
      }
   	 $w3->getDBObj()->query("DELETE FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items WHERE menu_bar_itemID = '$menu_bar_itemID'");

   	 $w3->getDBObj()->query("UNLOCK TABLES");
   	}

   public static function selectMenuBarItemCategory($w3)
    {
     // Return an array of wm3GUIOption objects for menu item categories select
     $array = array();
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories
                             ORDER BY position DESC");
     while($row = $w3->getDBObj()->fetch($rs))
      array_push($array,new wm3GUIOption($w3->getLanguageObj()->translate($row->name),$row->categoryID));
     return $array;
    }


   public static function getMenuBarItemCategoryName($w3,$categoryID)
    {
     // Get menu item category name
     $rs = $w3->getDBObj()->query("SELECT name FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items_categories WHERE categoryID = '$categoryID'");
     $row = $w3->getDBObj()->fetch($rs);
     return $w3->getLanguageObj()->translate($row->name);
    }

   public static function selectMenuBarItemPosition($w3)
    {
     // Return an array of wm3GUIOption objects for menu item position select
     $array = array(); $i = 1;
     $rs = $w3->getDBObj()->query("SELECT * FROM ".WM3_cCONFIG_DB_PREFIX."_menu_bars_items");
     while($row = $w3->getDBObj()->fetch($rs))
      {
       array_push($array,new wm3GUIOption($i,$i));
       $i++;
      }
     if($w3->getAction() == WM3_cACTION_ADD_MENU_BAR_ITEM) array_push($array,new wm3GUIOption($i,$i));
     return $array;
    }

  }

?>
